1012
%{
#include "StdH.h" 
#include "EntitiesMP/Player.h"
#include "EntitiesMP/PlayerWeapons.h"
%}



class CPlayerController: CMovableModelEntity {
name "PlayerController";
thumbnail "PlayerController\\PlayerController.tbn";
features  "HasName", "IsTargetable";

properties:
 1 CTString m_strName          "Name" 'N' = "Player Controller",
 2 BOOL b_Autostart            "Auto start" 'A' = TRUE,
 //Player's controls
 
 4 FLOAT f_PlayerTranslationSpeed  "Translation speed" 'T' = 1.0f,
 5 BOOL b_ShowWeapons              "Show weapons"      'W' = TRUE,
 6 BOOL b_Shoot                    "Shooting weapons"  'S' = TRUE,
 7 BOOL b_ShowPlayerHud            "Show HUD"          'H' = TRUE,
 8 BOOL b_FlomasterUsingOnStart    "Have flomaster"    'F' = TRUE,
 9 BOOL b_InvisiblePlayer          "InvisiblePlayer"   'I' = FALSE,
10 BOOL b_SwapWeapons              "Swaping weapons"   'C' = TRUE,
11 FLOAT f_PaintDist               "Flomaster Paint Distance"  'P' = 3.0f,
//12 INDEX i_CountLifesForMatch      "Death match life count" 'D' = 5,
//13 INDEX i_CountOfPainting         "Ammount of painting" 'M' = 1000,
 
 components:
 1 model   MODEL      "ModelsMP\\Editor\\EnvironmentParticlesHolder.mdl",
 2 texture TEXTURE    "ModelsMP\\Editor\\EnvironmentParticlesHolder.tex",
 
 functions:

  CPlayer* GetRealPlayerEntity(CEntityPointer pen_player)
  {
  CPlayer *penRealPlayer = (CPlayer*)&*pen_player;
  return penRealPlayer;
  }
  CPlayerWeapons* GetCurrentPlayerWeapons(CEntityPointer pen_player2)
  {
  CPlayer *pen_ToPlayerReal = GetRealPlayerEntity(pen_player2);
  CEntityPointer  currentWeaponsPenEntity = pen_ToPlayerReal->m_penWeapons;
  CPlayerWeapons *currentWeaponsPenReal = (CPlayerWeapons*)&*currentWeaponsPenEntity;
  return currentWeaponsPenReal;
  }  
  
  void SetPlayerTranslationSpeed(CEntityPointer pen_Player_3, FLOAT f_ValueSpeed)
  {
  GetCurrentPlayerWeapons(pen_Player_3)->f_transmultiplier = f_ValueSpeed; 
  }
  void ShowPlayerWeapons(CEntityPointer pen_Player_3, BOOL b_Option)
  {
  GetCurrentPlayerWeapons(pen_Player_3)->b_ShowWeapons = b_Option; 
  }
  void WeaponsCanShoot(CEntityPointer pen_Player_3,BOOL b_Option)
  {
  GetCurrentPlayerWeapons(pen_Player_3)->b_ShootingWeapons = b_Option;
  }
  void SwapWeapons(CEntityPointer pen_Player_3,BOOL b_Option)
  {
  GetCurrentPlayerWeapons(pen_Player_3)->b_SwappingWeapons = b_Option;
  }
  void ControllPlayerHUD(CEntityPointer pen_Player_3,BOOL b_Option)
  {
  GetCurrentPlayerWeapons(pen_Player_3)->b_ShowPlayerHud = b_Option;
  }
  void ControllFlomaster(CEntityPointer pen_Player_3,BOOL b_Option)
  {
  GetCurrentPlayerWeapons(pen_Player_3)->b_CanPaint = b_Option;
  }
  void ControlPlayerVisiblities(CEntityPointer pen_Player_3,BOOL b_Option)
  {
  if(b_Option == TRUE){GetRealPlayerEntity(pen_Player_3)->SwitchToEditorModel();}
  if(b_Option == FALSE){GetRealPlayerEntity(pen_Player_3)->SwitchToModel();}
  }
  void ControlFlomasterPaintDistance(CEntityPointer pen_Player_3,FLOAT f_Option)
  {
  GetCurrentPlayerWeapons(pen_Player_3)->f_PaintDistance = f_Option;
  }
  
  /* void SetPalyersLifeCount(CEntityPointer pen_Player_3,INDEX i_Option)
  {
  if(GetCurrentPlayerWeapons(pen_Player_3)->b_LifeSet == FALSE)
  {
  GetCurrentPlayerWeapons(pen_Player_3)->i_Lifes = i_Option;
  GetCurrentPlayerWeapons(pen_Player_3)->b_LifeSet = TRUE;
  }
  
  }
  void SetPaintAmmount(CEntityPointer pen_Player_3,INDEX i_Option)
  {
  if(GetCurrentPlayerWeapons(pen_Player_3)->b_PaintAmmountSet == FALSE)
  {
  GetCurrentPlayerWeapons(pen_Player_3)->i_PaintAmout = i_Option;
  GetCurrentPlayerWeapons(pen_Player_3)->b_PaintAmmountSet = TRUE;
  }
  } */
  
 
 procedures:
  
 Main()
  {
   //model
   InitAsEditorModel();
   GetModelObject()->StretchModel(FLOAT3D(1.0f,1.0f,1.0f));
   //Set model
   SetModel(MODEL);
   SetModelMainTexture(TEXTURE);
  
   SetPhysicsFlags(EPF_MODEL_FIXED);
   SetCollisionFlags(EPF_MODEL_IMMATERIAL);
   
   //Start by trygger or by boolean value
   wait() {
   on (ETrigger eTrigger) : { stop; }
   otherwise():{ if(b_Autostart == TRUE){stop;}}
   } 

   //Appliing changes to all players in world
  FOREACHINDYNAMICCONTAINER(GetWorld()->wo_cenEntities, CEntity, iten)
  { 
   CEntity *pen = iten;
    if (IsDerivedFromClass(pen, "Player"))
    {
    //Appliing changes
    SetPlayerTranslationSpeed(pen,f_PlayerTranslationSpeed);
    ShowPlayerWeapons(pen,b_ShowWeapons);
    WeaponsCanShoot(pen,b_Shoot);
    SwapWeapons(pen,b_SwapWeapons);
    ControllPlayerHUD(pen,b_ShowPlayerHud);
    ControllFlomaster(pen,b_FlomasterUsingOnStart);
    ControlPlayerVisiblities(pen,b_InvisiblePlayer);
	ControlFlomasterPaintDistance(pen,f_PaintDist);
	//SetPalyersLifeCount(pen,i_CountLifesForMatch);
	//SetPaintAmmount(pen,i_CountOfPainting);
    }
   }
   
   
   
  }
   
   
   
  

};